/* buffer.c - Aprile 1999 - E.V.
   buffer circolare su vettore */

#include <stdlib.h>
#define MAX 8


struct buffer{
             int buffer[MAX];
             int old;
             int new;
            };

void main(void);
/* acquisisce caratteri da tastiera, li memorizza e li estrae con
   disciplina FIFO su un buffer circolare */
void insert(struct buffer * buffer_ptr);
/* se il buffer non e' pieno inserisce un elemento;
   altrimenti segnala l'eccezione */
void extract(struct buffer * buffer_ptr);
/* se il buffer non e' vuoto estrae un elemento;
   altrimenti segnala l'eccezione */
int push(struct buffer * buffer_ptr, int value);
/* se buffer non e' pieno inserisce value e restituisce 1;
   altrimenti restituisce 0 */
int pop(struct buffer * buffer_ptr, int * value_ptr);
/* se buffer non e' vuoto estrae il valore in testa, lo copia in *value_ptr
   e restituisce 1;
   altrimenti restituisce 0 */
void init(struct buffer * buffer_ptr);
/* inizializza lo buffer */

void main()
/* acquisisce caratteri da tastiera, li memorizza e li estrae con
   disciplina FIFO */
{
  struct buffer buffer;
  int selection;

  init(&buffer);
  do
  { printf("\n\n select next action: \n 1 for Insert, 2 for Extract, 0 for Stop) >");
    scanf("%d",&selection);
    switch(selection)
    {case 1:
            insert(&buffer);
            break;
     case 2:
            extract(&buffer);
            break;
    }
  }while(selection!=0);
}

void insert(struct buffer * buffer_ptr)
/* se il buffer non e' pieno inserisce un elemento;
   altrimenti segnala l'eccezione */
{
   int value;
   int result;

   printf("\n value>");
   scanf("%d", &value);

   result=push(buffer_ptr, value);
   if(result==0)
   { printf("\n Buffer full!");
   }
}

void extract(struct buffer * buffer_ptr)
/* se il buffer non e' vuoto estrae un elemento;
   altrimenti segnala l'eccezione */
{
   int value;
   int result;


   result=pop(buffer_ptr, &value);
   if(result==1)
   { printf("\n value = %d",value);
   }
   else
   { printf("\n Buffer empty!");
   }
}

void init(struct buffer * buffer_ptr)
/* inizializza il buffer per avere old=new */
{
   buffer_ptr->new=0;
   buffer_ptr->old=0;
}

int push(struct buffer * buffer_ptr, int value)
/* se buffer non e' pieno inserisce value e restituisce 1;
   altrimenti restituisce 0
   buffer pieno e' testato come (new+1)%MAX=old
   */
{
  if((buffer_ptr->new+1)%MAX!=buffer_ptr->old)
  {
    buffer_ptr->buffer[buffer_ptr->new]=value;
    buffer_ptr->new=(buffer_ptr->new+1)%MAX;
    return 1;
  }else
  { return 0;
  }
}


int pop(struct buffer * buffer_ptr, int * value_ptr)
/* se buffer non e' vuoto estrae il valore in testa, lo copia in *value_ptr
   e restituisce 1;
   altrimenti restituisce 0 */
{
  if(buffer_ptr->old != buffer_ptr->new)
  { *value_ptr=buffer_ptr->buffer[buffer_ptr->old];
    buffer_ptr->old=(buffer_ptr->old+1)%MAX;
    return 1;
  }else
  { return 0;
  }
}


